import { useWidgetContext } from '../context';
import { useLucene } from './useLucene';
export var filterTasksQueries = function (accountId) { return ({
    newSessionQuery: "+(-\\/teaching_ownerId:* -\\/teaching_is_handedover:\"true\" -ogit\\/Knowledge\\/archived:\"true\")",
    startedSessionQuery: "+(+\\/teaching_ownerId:\"" + accountId + "\" -\\/teaching_without_issue:\"true\" -ogit\\/Knowledge\\/archived:\"true\")",
    reviewSessionQuery: "+(+\\/teaching_reviewer_ids:*" + accountId + "* (-\\/teaching_is_handedover:\"true\" -ogit\\/Knowledge\\/archived:\"true\"))",
}); };
export var filterConversionQueries = function (accountId) { return ({
    newSessionQuery: "+(-\\/teaching_conversion_ownerId:* +\\/teaching_is_handedover:\"true\" -ogit\\/Knowledge\\/archived:\"true\")",
    startedSessionQuery: "+(+\\/teaching_conversion_ownerId:\"" + accountId + "\" +\\/teaching_is_handedover:\"true\" -ogit\\/Knowledge\\/archived:\"true\")",
    reviewSessionQuery: "+(+\\/conversion_reviewer_ids:*" + accountId + "* (+\\/teaching_is_handedover:\"true\" -ogit\\/Knowledge\\/archived:\"true\"))",
}); };
var configureQuery = function (filterQuery) {
    var baseQuery = '+(ogit\\/_type:"ogit/Knowledge/AcquisitionSession")';
    return {
        querystring: baseQuery + " " + filterQuery,
        params: { limit: -1, count: 'true' },
    };
};
export var useWelcomeWidgetConfig = function (filterQueriesCallback) {
    var _a = useWidgetContext(), client = _a.client, _b = _a.provider, selectMe = _b.selectMe, selectAppsIds = _b.selectAppsIds, openApp = _b.openApp, selectScopeId = _b.selectScopeId, title = _a.config.title;
    var me = selectMe();
    var scopeId = selectScopeId();
    var _c = filterQueriesCallback(me.id), newSessionQuery = _c.newSessionQuery, startedSessionQuery = _c.startedSessionQuery, reviewSessionQuery = _c.reviewSessionQuery;
    var configuredNewSessionQuery = configureQuery(newSessionQuery);
    var configuredStartedSessionQuery = configureQuery(startedSessionQuery);
    var configuredReviewSessionQuery = configureQuery(reviewSessionQuery);
    var newSessionsCount = useLucene(client, configuredNewSessionQuery, scopeId, [0])[0];
    var startedSessionsCount = useLucene(client, configuredStartedSessionQuery, scopeId, [0])[0];
    var reviewSessionCount = useLucene(client, configuredReviewSessionQuery, scopeId, [0])[0];
    var sessionCounts = [
        newSessionsCount,
        startedSessionsCount,
        reviewSessionCount,
    ];
    var loading = sessionCounts.some(function (_a) {
        var loading = _a.loading;
        return loading;
    });
    var error = sessionCounts.some(function (_a) {
        var error = _a.error;
        return error;
    });
    var atqId = selectAppsIds().atqId;
    var greeting = title + " " + me.displayName + "!";
    var formattedNewSessionsCount = newSessionsCount.result[0];
    var formattedStartedSessionsCount = startedSessionsCount.result[0];
    var formattedReviewSessionCount = reviewSessionCount.result[0];
    return {
        openApp: openApp,
        loading: loading,
        error: error,
        atqId: atqId,
        greeting: greeting,
        formattedNewSessionsCount: formattedNewSessionsCount,
        formattedStartedSessionsCount: formattedStartedSessionsCount,
        formattedReviewSessionCount: formattedReviewSessionCount,
    };
};
