var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { BarChart, Bar, XAxis, YAxis, CartesianGrid, Tooltip, ResponsiveContainer, } from 'recharts';
import { BarChartTooltipWrapper, ResponsiveContainerWrapper, WrappedBarChartTooltipLabel, } from './styles';
var CustomTooltip = function (_a) {
    var value = _a.value, label = _a.label;
    return (React.createElement(BarChartTooltipWrapper, null,
        React.createElement(WrappedBarChartTooltipLabel, null,
            label,
            React.createElement("br", null),
            value)));
};
export var StackedBarChart = function (_a) {
    var dataList = _a.dataList, barList = _a.barList, _b = _a.axisProps, axisProps = _b === void 0 ? {} : _b, _c = _a.gridProps, gridProps = _c === void 0 ? {} : _c;
    var bars = barList.map(function (bar) { return (React.createElement(Bar, { key: bar.dataKey, dataKey: bar.dataKey, stackId: "a", fill: bar.fillColor, isAnimationActive: true })); });
    return (React.createElement(ResponsiveContainerWrapper, null,
        React.createElement(ResponsiveContainer, { width: "98%" },
            React.createElement(BarChart, { data: dataList, margin: {
                    top: 30,
                } },
                React.createElement(CartesianGrid, __assign({}, gridProps)),
                React.createElement(XAxis, __assign({ dataKey: "name" }, axisProps)),
                React.createElement(YAxis, __assign({}, axisProps)),
                React.createElement(Tooltip, { isAnimationActive: false, cursor: false, content: function (_a) {
                        var active = _a.active, payload = _a.payload, label = _a.label;
                        var value = "value: " + (payload && payload.length && payload[0] ? payload[0].value : '');
                        return active ? (React.createElement(CustomTooltip, { value: value, label: label })) : null;
                    } }),
                bars))));
};
