import { useCallback, useEffect, useRef, useState } from 'react';
var DEFAULT_TRESHOLD = 150;
export function useInfiniteScroll(_a) {
    var loading = _a.loading, hasNextPage = _a.hasNextPage, onLoadMore = _a.onLoadMore, _b = _a.threshold, threshold = _b === void 0 ? DEFAULT_TRESHOLD : _b;
    var ref = useRef(null);
    var _c = useState(false), loadedUntilScroll = _c[0], setLoadedUntilScroll = _c[1];
    var loadMoreItems = loading || !hasNextPage ? function () { } : function () { return onLoadMore(); };
    var handleScroll = useCallback(function () {
        var _a;
        var parent = (_a = ref.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        if (parent &&
            parent.scrollTop + parent.clientHeight >= parent.scrollHeight - threshold) {
            loadMoreItems();
        }
    }, [loadMoreItems, threshold]);
    useEffect(function () {
        var _a;
        var parent = (_a = ref.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        if (parent) {
            parent.addEventListener('scroll', handleScroll);
            return function () {
                parent.removeEventListener('scroll', handleScroll);
            };
        }
    }, [handleScroll]);
    useEffect(function () {
        var _a;
        var child = ref.current;
        var parent = (_a = ref.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        if (!loadedUntilScroll && child && parent) {
            var parentBottom = parent.getBoundingClientRect().bottom;
            var childBottom = child.getBoundingClientRect().bottom;
            if (childBottom <= parentBottom) {
                loadMoreItems();
            }
            else {
                setLoadedUntilScroll(true);
            }
        }
    }, [loading, loadedUntilScroll, loadMoreItems]);
    return ref;
}
