import styled from 'styled-components';
import defaultTheme from "../../../theme";
import { textAlign, paddable, raised } from "../../../utils";
import { Button } from "../../inputs/Button";
export var Segment = styled.div.withConfig({ displayName: "Segment", componentId: "sc-11aa9nx" })({
    position: 'relative',
    overflow: 'hidden auto',
    display: 'block',
    margin: '1rem 0',
    padding: '1em 1em',
}, 
// Themed styling
function (_a) {
    var theme = _a.theme, color = _a.color, fitted = _a.fitted;
    return ({
        backgroundColor: color ? theme.colors[color].default : undefined,
        color: color ? theme.colors.white.default : undefined,
        margin: fitted ? 0 : '1rem 0',
    });
}, 
// Placeholder
function (_a) {
    var _b;
    var $placeholder = _a.$placeholder;
    return $placeholder
        ? (_b = {
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'center',
                alignItems: 'stretch',
                textAlign: 'center',
                maxWidth: 'initial',
                animation: 'none',
                overflow: 'visible',
                minHeight: '18rem'
            },
            _b[Button] = {
                maxWidth: '15rem',
                marginLeft: 'auto',
                marginRight: 'auto',
            },
            _b) : null;
}, 
// Helpers
textAlign, paddable, raised);
Segment.defaultProps = {
    theme: defaultTheme,
};
