var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback, useEffect, useState, useRef } from 'react';
import styled from 'styled-components';
import defaultTheme from "../../../theme";
import { Icon } from "../../elements";
import { StyledInput } from './StyledInput';
var SearchDiv = styled.div.withConfig({ displayName: "SearchDiv", componentId: "sc-11ny45i" })(function () {
    var _a;
    return (_a = {
            position: 'relative',
            display: 'inline-block',
            '& > i': {
                cursor: 'pointer',
                position: 'absolute',
                right: '0.5em',
                height: '100%',
                top: '-2px',
                display: 'flex',
                alignItems: 'center',
                width: 20,
                justifyContent: 'center',
            }
        },
        _a[StyledInput] = {
            paddingRight: '2.2em',
        },
        _a);
}, function (_a) {
    var _b;
    var open = _a.open;
    return open
        ? (_b = {},
            _b[StyledInput] = {
                borderBottomLeftRadius: 0,
                borderBottomRightRadius: 0,
            },
            _b) : null;
}, function (_a) {
    var fluid = _a.fluid;
    return (fluid ? { width: '100%' } : null);
});
SearchDiv.defaultProps = {
    theme: defaultTheme,
};
var Results = styled.div.withConfig({ displayName: "Results", componentId: "sc-t5bzhz" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: absolute;\n  top: 2em;\n  left: 0;\n  right: 0;\n  z-index: 100;\n\n  background-color: white;\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  border: 1px solid ", ";\n  max-height: 16em;\n  overflow-x: hidden;\n  overflow-y: auto;\n  box-sizing: border-box;\n"], ["\n  position: absolute;\n  top: 2em;\n  left: 0;\n  right: 0;\n  z-index: 100;\n\n  background-color: white;\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  border: 1px solid ", ";\n  max-height: 16em;\n  overflow-x: hidden;\n  overflow-y: auto;\n  box-sizing: border-box;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, function (_a) {
    var theme = _a.theme;
    return theme.colors.primary.light;
});
Results.defaultProps = {
    theme: defaultTheme,
};
export var Search = function (_a) {
    var onClear = _a.onClear, children = _a.children, className = _a.className, rest = __rest(_a, ["onClear", "children", "className"]);
    var ref = useRef(null);
    var _b = useState(false), isOpen = _b[0], setOpen = _b[1];
    // Re-open or close
    var handleClick = useCallback(function (e) {
        var _a;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) {
            setOpen(true);
            return;
        }
        setOpen(false);
    }, []);
    useEffect(function () {
        document.addEventListener('mousedown', handleClick, false);
        return function () { return document.removeEventListener('mousedown', handleClick, false); };
    }, [handleClick]);
    var showResults = isOpen && !!children;
    return (React.createElement(SearchDiv, { ref: ref, open: showResults, fluid: rest.fluid, className: className },
        React.createElement(StyledInput, __assign({}, rest)),
        React.createElement(Icon, { color: rest.color || 'primary', name: rest.value ? 'times' : 'search', onClick: onClear }),
        showResults && React.createElement(Results, null, children)));
};
var templateObject_1;
